//--------------------------------------------------------------
// File     : main.c
// Datum    : 19.07.2013
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : STM32F4
// IDE      : CooCox CoIDE 1.7.0
// Module   : CMSIS_BOOT, M4_CMSIS_CORE
// Funktion : Demo der SRAM-Library
// Hinweis  : Diese zwei Files muessen auf 8MHz stehen
//              "cmsis_boot/stm32f4xx.h"
//              "cmsis_boot/system_stm32f4xx.c"
//--------------------------------------------------------------

#include "main.h"
#include "stm32_ub_sram.h"
#include "stm32_ub_led.h"

void Delay(__IO uint32_t nCount)
{
  while(nCount--)
  {
  }
}


int main(void)
{
  uint32_t adr;
  uint16_t sollwert, istwert;
  ErrorStatus ramcheck;


  SystemInit(); // Quarz Einstellungen aktivieren

  // Init der Orangen LED
  UB_Led_Init();

  // init vom externen SRAM (und test ob es vorhanden ist)
  ramcheck=UB_SRAM_Init();
  if(ramcheck==SUCCESS) {
	// zum test RAM komplett fllen
	sollwert=0xA1B2;
	for(adr=0;adr<SRAM_MAX_ADR;adr++) {
		UB_SRAM_Write(adr,sollwert);
		sollwert++;
	}

	// Ram wieder auslesen und prfen
	sollwert=0xA1B2;
	for(adr=0;adr<SRAM_MAX_ADR;adr++) {
		istwert=UB_SRAM_Read(adr);
		if(istwert!=sollwert) {
		  // RAM-Inhalt fehlerhaft
		  ramcheck=ERROR;
		}
		sollwert++;
	}
  }

  while(1)
  {
	  if(ramcheck==SUCCESS) {
		  // wenn kein Fehler -> LED leuchtet
		  UB_Led_On(LED_ORANGE);
	  }
	  else {
		  // wenn Fehler -> LED blinke
		  UB_Led_Toggle(LED_ORANGE);
		  Delay(500000);
	  }
  }
}
